
/* Chrysalide - Outil d'analyse de fichiers binaires
 * checks.h - prototypes pour les validations liées au format DWARF v2
 *
 * Copyright (C) 2018 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_DWARF_V2_CHECKS_H
#define _PLUGINS_DWARF_V2_CHECKS_H


#include <stdbool.h>


#include "../def.h"



/* Procède à la conversion de base d'une abréviation DWARF. */
bool check_dwarfv2_abbrev_decl(const dw_abbrev_decl *);

/* Procède à la conversion d'un attribut d'abréviation DWARF. */
bool check_dwarfv2_abbrev_attrib(const dw_abbrev_raw_attr *);



#endif  /* _PLUGINS_DWARF_V2_CHECKS_H */
